.TH

.\" NAME should be all caps, SECTION should be 1-8, maybe w/ subsection
.\" other parms are allowed: see man(7), man(1)
.\" denote multiple entry points thus; makewhatis(8) will catch them
.SH NAME

Eval, floating point expression evaluator

.SH SYNOPSIS

Eval [expression|eval command]

.SH "DESCRIPTION"

.I Eval
is a floating point expression evaluator much like bc.
Note the
capital "E" to distinguish
.I Eval
from the Unix
.I eval.
.I Eval
is meant for
quick numeric calculations.  It differs from
.I bc
in that it does not have
arbitrary precision, it does not support a programmable language, it is
friendlier, and it has more built in functions and constants.
.I Eval
has fully built-in documentation.  Just run it without any
arguments.  To print out the built-in documentation, type
.PP
Eval help > ehelp.txt
.PP
and then print the file ehelp.txt.  The full ANSI C source
for
.I Eval
is freely distributable and modifiable, so you can taylor it to
your liking if you so desire.

.SH OPTIONS

You can optionally specify an
.I Eval
command or expression on the command
line, and
.I Eval
will evaluate that expression and quit.  Usually you'll
want to put quotes around the expression so that Unix doesn't try to
interpret special characters like *.

.SH EXAMPLES

Eval "1+350/511-sin(2*_pi*.3)"

_pi is a built-in constant.  For more about these, see the built-in
documentation.

.SH FILES

/usr/local/bin/Eval -- the executable

.SH "SEE ALSO"

bc, dc

.SH AUTHOR

http://willus.com (as of 9/04)
